#! /usr/local/bin/ruby

require 'curl'

### http
w = Curl.new
w.url = 'http://www.ruby-lang.org/'
#w.proxy = 'proxy.your.domain:8080'      # edit here!
w.followlocation = true
w.timeout = 20
#w.verbose = true
#w.stderr = 'err'
w.perform
puts w.body_str
puts w.header_str
exit

### http post
w = Curl.new
w.url = 'http://some.where/'             # edit here!
w.postfields = 'prm1=A&prm2=B'           # edit here!
w.perform
puts w.body_str
exit


### ftp get
ENV['NO_PROXY'] = '*'
w = Curl.new
w.url = 'ftp://some.where/'              # edit here!
w.userpwd = 'your:password'              # edit here!
w.timeout = 10
#w.ftplistonly = true
w.verbose = true
w.file = 'TEST'                          # edit here!
w.perform
exit

### ftp upload
ENV['NO_PROXY'] = '*'
w = Curl.new
w.url = 'ftp://some.where/'              # edit here!
w.userpwd = 'your:password'              # edit here!
w.infile = 'TEST'                        # edit here!
#w.input_str = "test\nstrings\n"         # edit here!
w.upload = true
w.verbose = true
w.perform
puts w.body_str
exit


### passwd function
w = Curl.new
w.url = 'ftp://some.where/'              # edit here!
w.userpwd = 'your:password'              # edit here!
w.passwdfunction = Proc.new {|prompt|
  puts prompt
  gets.chomp
}
w.perform
puts w.body_str
exit

### progress function
ENV['NO_PROXY'] = '*'
w = Curl.new
w.url = 'ftp://some.where/'              # edit here!
w.userpwd = 'your:password'              # edit here!
w.progressfunction = Proc.new {|t,n,tu,nu|
  puts "#{n}/#{t}"
}
#w.verbose = true
w.timeout = 10
w.perform
exit
